; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2014 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

EnableExplicit

Global PLReader_xLine.s
Global PLReader_Counter.i
Global PLReader_FetchTag_FoundResult.s
Global PLReader_FetchTag_FindInner.s

Procedure.s PLWriter_GetPlaylistTitle(Filename.s)
  Define.s xResult

  Define.i xLong1
  xResult = SimpleFile(Filename)
  xLong1 = InStrRevChar(xResult, 46) ;"."
  If xLong1
    xResult = Left(xResult, xLong1 - 1)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i PLReader_IsPureFile(xPLPath.s)
  Define.i xResult

  If LCase(Left(PLReader_xLine, 5)) = "file:"
    xResult = #True
    PLReader_xLine = ReplaceString(Mid(PLReader_xLine, 6), "/", "\")
    If Left(PLReader_xLine, 2) = "\\"
      While Left(PLReader_xLine, 3) = "\\\"
        PLReader_xLine = Mid(PLReader_xLine, 2)
        Wend
      If Mid(PLReader_xLine, 4, 2) = ":\"
        PLReader_xLine = Mid(PLReader_xLine, 3)
        EndIf
      Else
      If Left(PLReader_xLine, 1) = "\"
        PLReader_xLine = Mid(PLReader_xLine, 2)
        EndIf
      If Not Mid(PLReader_xLine, 2, 2) = ":\"
        PLReader_xLine = GetFullFromRelativeFilename(xPLPath, PLReader_xLine)
        EndIf
      EndIf
    Else
    If (FindString(PLReader_xLine, "://") = 0)
      xResult = #True
      PLReader_xLine = ReplaceString(PLReader_xLine, "/", "\")
      If Not (Mid(PLReader_xLine, 2, 2) = ":\" Or Left(PLReader_xLine, 2) = "\\")
        PLReader_xLine = GetFullFromRelativeFilename(xPLPath, PLReader_xLine)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; Pure Non-Calym-playlist stuff only
; LoadPList stuffs use byref, allowing them to clear the buffer before further processing!
Procedure PLReader_Open_PlsAap(hTextFileIn.i, Filename.s, xLine.s, EntryString.s)
  Define.s xPLPath
  Define.i xCounter
  Define.i xEStrLen
  Define.i xLong3
  PLReader_xLine = xLine
  PLReader_Counter = 0

  CompilerIf #UseFileLogging
    If EntryString = "File"
      MainForm_ctConsoleA_AddLog("  (pls playlist)")
      Else
      MainForm_ctConsoleA_AddLog("  (aap Apollo playlist)")
      EndIf
    CompilerEndIf
  xPLPath = SimpleDir(Filename)
  xEStrLen = Len(EntryString)
  Repeat
    If LCase(Left(PLReader_xLine, xEStrLen)) = EntryString
      xLong3 = FindString(PLReader_xLine, "=", xEStrLen + 1)
      If Not (xLong3 = 0 Or xLong3 = Len(PLReader_xLine))
        PLReader_xLine = Mid(PLReader_xLine, xLong3 + 1)
        If PLReader_IsPureFile(xPLPath)
          If Not xCounter = sCharA1Max
            If RemoveMissingOnPLLoad
              If AllowedItem(PLReader_xLine, #True) = 1
                sCharA1(xCounter) = PLReader_xLine
                xCounter = xCounter + 1
                EndIf
              ElseIf AllowedItemSongFast(PLReader_xLine, #True)
              sCharA1(xCounter) = PLReader_xLine
              xCounter = xCounter + 1
              EndIf
            EndIf
          Else
          RadioForm_AddRadioEx(PLReader_xLine, PLReader_xLine, "", #False)
          EndIf
        EndIf
      EndIf
    PLReader_Counter = (PLReader_Counter + 1) % 64
    If PLReader_Counter = 0
      DoEventsEx_SleepPeriodicalLW(0)
      If AbortReading
        Break
        EndIf
      EndIf
    
    If Not TxtFileReader_NextLine(hTextFileIn)
      Break
      EndIf
    PLReader_xLine = TxtFileReader_GetLineString(hTextFileIn)
    ForEver
  GenCalaymStructure(#True, xCounter, xSorting)
  EndProcedure

Procedure PLReader_Open_M3uGeneric(hTextFileIn.i, Filename.s, xLine.s)
  Define.s xPLPath.s
  Define.i xCounter.i
  PLReader_xLine = xLine
  PLReader_Counter = 0

  CompilerIf #UseFileLogging
    MainForm_ctConsoleA_AddLog("  (m3u playlist)")
    CompilerEndIf
  xPLPath = SimpleDir(Filename)
  Repeat
    If Not Left(PLReader_xLine, 1) = "#"
      If PLReader_IsPureFile(xPLPath)
        If Not xCounter = sCharA1Max
          If RemoveMissingOnPLLoad
            If AllowedItem(PLReader_xLine, #True) = 1
              sCharA1(xCounter) = PLReader_xLine
              xCounter = xCounter + 1
              EndIf
            ElseIf AllowedItemSongFast(PLReader_xLine, #True)
            sCharA1(xCounter) = PLReader_xLine
            xCounter = xCounter + 1
            EndIf
          EndIf
        Else
        RadioForm_AddRadioEx(PLReader_xLine, PLReader_xLine, "", #False)
        EndIf
      EndIf
    PLReader_Counter = (PLReader_Counter + 1) % 64
    If PLReader_Counter = 0
      DoEventsEx_SleepPeriodicalLW(0)
      If AbortReading
        Break
        EndIf
      EndIf
    If Not TxtFileReader_NextLine(hTextFileIn)
      Break
      EndIf
    PLReader_xLine = TxtFileReader_GetLineString(hTextFileIn)
    ForEver
  GenCalaymStructure(#True, xCounter, xSorting)
  EndProcedure

Procedure PLReader_Open_Wpl(hTextFileIn.i, Filename.s, xLine.s)
  Define.s xPLPath
  Define.i xCounter
  Define.i xFindPos1
  Define.i xLong1
  Define.i xLong2
  Define.s xChar1
  PLReader_xLine = xLine
  PLReader_Counter = 0

  CompilerIf #UseFileLogging
    MainForm_ctConsoleA_AddLog("  (wpl playlist)")
    CompilerEndIf
  xPLPath = SimpleDir(Filename)
  Repeat
    Repeat
      PLReader_Counter = (PLReader_Counter + 1) % 64
      If PLReader_Counter = 0
        DoEventsEx_SleepPeriodicalLW(0)
        If AbortReading
          Break
          EndIf
        EndIf
      xFindPos1 = FindString(PLReader_xLine, "<media ", xFindPos1 + 1, #PB_String_NoCase)
      If xFindPos1 = 0
        Break
        EndIf
;AddThis
      xLong1 = FindString(PLReader_xLine, ">", xFindPos1 + 7)
      If xLong1 = 0
        xFindPos1 = Len(PLReader_xLine): Return
        EndIf
      xChar1 = Mid(PLReader_xLine, xFindPos1 + 6, xLong1 - xFindPos1 - 6)
      xFindPos1 = xLong2
      
      xLong1 = FindString(xChar1, " src=" + Chr(34))
      If xLong1 = 0
        Return
        EndIf
      xLong2 = FindString(xChar1, Chr(34), xLong1 + 6)
      If xLong2 = 0
        Return
        EndIf
      xChar1 = Trim(Mid(xChar1, xLong1 + 6, xLong2 - xLong1 - 6))
      If PLReader_IsPureFile(xPLPath)
        If Not xCounter = sCharA1Max
          If RemoveMissingOnPLLoad
            If AllowedItem(xChar1, #True) = 1
    ;Debug "Add:" + xChar1
              sCharA1(xCounter) = xChar1
              xCounter = xCounter + 1
              EndIf
            ElseIf AllowedItemSongFast(xChar1, #True)
            sCharA1(xCounter) = xChar1
            xCounter = xCounter + 1
            EndIf
          EndIf
        Else
        RadioForm_AddRadioEx(xChar1, xChar1, "", #False)
        EndIf
      ForEver
    If Not TxtFileReader_NextLine(hTextFileIn)
      Break
      EndIf
    PLReader_xLine = TxtFileReader_GetLineString(hTextFileIn)
    ForEver
  GenCalaymStructure(#True, xCounter, xSorting)
  EndProcedure

Procedure.i PLReader_FetchTag(hTextFileIn.i, xFindTag.s)
  Define.i xResult
  Define.i xLong1
  Define.s xChar1

;Debug "PLReader_FetchTag: Enter"

SkipToNextTag:
  Repeat
    xLong1 = 0
    Repeat
      xLong1 = FindString(PLReader_xLine, "<", xLong1 + 1)
      If xLong1 = 0
        Break
        EndIf
      If LCase(Mid(PLReader_xLine, xLong1 + 1, Len(xFindTag))) = xFindTag
        Select Mid(PLReader_xLine, xLong1 + Len(xFindTag) + 1, 1)
          Case ">", " "
            Break
          EndSelect
        EndIf
      ForEver
    If xLong1
      Break
      EndIf
    PLReader_Counter = (PLReader_Counter + 1) % 64
    If PLReader_Counter = 0
      DoEventsEx_SleepPeriodicalLW(0)
      If AbortReading
        Break
        EndIf
      EndIf
    If Not TxtFileReader_NextLine(hTextFileIn)
      Break
      EndIf
    PLReader_xLine = TxtFileReader_GetLineString(hTextFileIn)
    ForEver
  If xLong1 = 0
    PLReader_xLine = ""
    Else
    PLReader_xLine = LTrim(Mid(PLReader_xLine, xLong1 + Len(xFindTag) + 1))
    Repeat
      xLong1 = FindString(PLReader_xLine, ">")
      If Not xLong1 = 0
        PLReader_FetchTag_FoundResult = RTrim(Left(PLReader_xLine, xLong1 - 1))
        PLReader_xLine = LTrim(Mid(PLReader_xLine, xLong1 + 1))
        xResult = #True
        Break
        EndIf
      If Len(PLReader_xLine) > 4096
        PLReader_xLine = ""
        Goto SkipToNextTag
        EndIf
      PLReader_Counter = (PLReader_Counter + 1) % 64
      If PLReader_Counter = 0
        DoEventsEx_SleepPeriodicalLW(0)
        If AbortReading
          Break
          EndIf
        EndIf

      If Not TxtFileReader_NextLine(hTextFileIn)
        Break
        EndIf
      PLReader_xLine = TxtFileReader_GetLineString(hTextFileIn)
      PLReader_xLine = PLReader_xLine + " " + xChar1
      ForEver
    EndIf
;Debug "PLReader_FetchTag: Done"
  ProcedureReturn xResult
  EndProcedure

Procedure.i PLReader_FetchToNextMarkup(hTextFileIn.i)
  Define.i xResult
  Define.i xLong1
  Define.s xChar1

SkipToNextTag:
  Repeat
    xLong1 = FindString(PLReader_xLine, "<")
    If Not xLong1 = 0
      xResult = #True
      PLReader_FetchTag_FindInner = Left(PLReader_xLine, xLong1 - 1)
      PLReader_xLine = Mid(PLReader_xLine, xLong1)
      Break
      EndIf
    If Len(PLReader_xLine) > 16384
      Break
      EndIf
    PLReader_Counter = (PLReader_Counter + 1) % 64
    If PLReader_Counter = 0
      DoEventsEx_SleepPeriodicalLW(0)
      If AbortReading
        Break
        EndIf
      EndIf
    If Not TxtFileReader_NextLine(hTextFileIn)
      Break
      EndIf
    PLReader_xLine = TxtFileReader_GetLineString(hTextFileIn)
    PLReader_xLine = PLReader_xLine + " " + xChar1
    ForEver
  ProcedureReturn xResult
  EndProcedure

Procedure PLReader_DynOpenXmlEnc(hTextFileIn.i, xFindTag.s)
  Define.i xResult

  xResult = #True
  PLReader_FetchTag_FoundResult = ""
  If PLReader_FetchTag(hTextFileIn, "?" + xFindTag)
    If FindString(PLReader_FetchTag_FoundResult, "UTF-8", 9, #PB_String_NoCase)
      If Not TxtFileReader_GetEncoding(hTextFileIn) = #CP_UTF8
        If Not TxtFileReader_SetEncodingReset(hTextFileIn, #CP_UTF8)
          xResult = #False
          Else
          ; ReOpen!
          PLReader_xLine = ""
          If Not PLReader_FetchTag(hTextFileIn, "?" + xFindTag)
            xResult = #False
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure PLReader_Open_Xspf(hTextFileIn.i, Filename.s, xLine.s)
  Define.s xPLPath
  Define.i xCounter
  Define.s xChar1
  Define.s xChar2
  PLReader_xLine = xLine
  PLReader_Counter = 0

  CompilerIf #UseFileLogging
    MainForm_ctConsoleA_AddLog("  (xspf playlist)")
    CompilerEndIf
  If PLReader_DynOpenXmlEnc(hTextFileIn, "xml")
    xPLPath = SimpleDir(Filename)
    PLReader_FetchTag_FoundResult = ""
    While PLReader_FetchTag(hTextFileIn, "location")
      PLReader_FetchTag_FindInner = xChar1
      If Not PLReader_FetchToNextMarkup(hTextFileIn)
        Break
        EndIf
      xChar1 = URLDecode(PLReader_FetchTag_FindInner)
      
      ;Debug "Process? " + xChar1
      xChar2 = PLReader_xLine
      PLReader_xLine = xChar1
      If PLReader_IsPureFile(xPLPath)
        xChar1 = PLReader_xLine
        PLReader_xLine = xChar2
        ;Debug "  File " + xChar1
        If Not xCounter = sCharA1Max
          If RemoveMissingOnPLLoad
            If AllowedItem(xChar1, #True) = 1
              sCharA1(xCounter) = xChar1
              xCounter = xCounter + 1
              EndIf
            ElseIf AllowedItemSongFast(xChar1, #True)
            sCharA1(xCounter) = xChar1
            xCounter = xCounter + 1
            EndIf
          EndIf
        Else
        xChar1 = PLReader_xLine
        PLReader_xLine = xChar2
        ;Debug "  URL " + xChar1
        RadioForm_AddRadioEx(xChar1, xChar1, "", #False)
        EndIf
      Wend
    GenCalaymStructure(#True, xCounter, xSorting)
    EndIf
  EndProcedure

Procedure PLReader_Open_AIMP(hTextFileIn.i, Filename.s, xLine.s, EntryString.s)
  Define.s xPLPath
  Define.i xCounter
  Define.i xEStrLen
  Define.i xLong3
  PLReader_xLine = xLine
  PLReader_Counter = 0

  CompilerIf #UseFileLogging
    If EntryString = "1|"
      MainForm_ctConsoleA_AddLog("  (AIMP2 playlist)")
      Else
      MainForm_ctConsoleA_AddLog("  (AIMP3 playlist)")
      EndIf
    CompilerEndIf
  xPLPath = SimpleDir(Filename)
  xEStrLen = Len(EntryString)
  Repeat
    If LCase(Left(PLReader_xLine, xEStrLen)) = EntryString
      xLong3 = FindString(PLReader_xLine, "|", xEStrLen + 1)
      If xLong3 = 0
        xLong3 = Len(PLReader_xLine) + 1
        EndIf
      If Not (xLong3 = xEStrLen + 1)
        PLReader_xLine = Mid(PLReader_xLine, xEStrLen + 1, xLong3 - xEStrLen - 1)
        If PLReader_IsPureFile(xPLPath)
          If Not xCounter = sCharA1Max
            If RemoveMissingOnPLLoad
              If AllowedItem(PLReader_xLine, #True) = 1
                sCharA1(xCounter) = PLReader_xLine
                xCounter = xCounter + 1
                EndIf
              ElseIf AllowedItemSongFast(PLReader_xLine, #True)
              sCharA1(xCounter) = PLReader_xLine
              xCounter = xCounter + 1
              EndIf
            EndIf
          Else
          RadioForm_AddRadioEx(PLReader_xLine, PLReader_xLine, "", #False)
          EndIf
        EndIf
      EndIf
    PLReader_Counter = (PLReader_Counter + 1) % 64
    If PLReader_Counter = 0
      DoEventsEx_SleepPeriodicalLW(0)
      If AbortReading
        Break
        EndIf
      EndIf
    If Not TxtFileReader_NextLine(hTextFileIn)
      Break
      EndIf
    PLReader_xLine = TxtFileReader_GetLineString(hTextFileIn)
    ForEver
  GenCalaymStructure(#True, xCounter, xSorting)
  EndProcedure

Procedure PLWriter_Save_M3uGeneric(hTxtFileOut.i)
  Define.i xLong1

  For xLong1 = 0 To PLCount - 1
    If (PLI(xLong1)\DirDepthFlags & #PLI_IsAuto) = 0
      If Not (PLI(xLong1)\DirDepthFlags & #PLI_IsDir) = #PLI_IsDir
        TxtFileWriter_WriteLine(hTxtFileOut, PLI(xLong1)\Filename)
        EndIf
      EndIf
    Next
  For xLong1 = 0 To xRadioCount - 1
    TxtFileWriter_WriteLine(hTxtFileOut, xRadioURL(xLong1))
    Next
  EndProcedure

Procedure.i PLWriter_Save_PlsAap(Filename.s, EntryString.s, ApolloAap.i) ;, UseUTF8 As Boolean) as boolean
  Define.i xResult
  Define.i hTxtFileOut
  Define.i xLong1
  Define.i xLong2

  CompilerIf #UseFileLogging
    If ApolloAap
      MainForm_ctConsoleA_AddLog("Saving playlist (Apollo aap ansi): " + Filename)
      Else
      MainForm_ctConsoleA_AddLog("Saving playlist (Generic pls ansi): " + Filename)
      EndIf
    CompilerEndIf

  hTxtFileOut = TxtFileWriter_CreateFileEx(Filename, #CP_ACP, #False)
  If Not hTxtFileOut = 0
    If ApolloAap
      TxtFileWriter_WriteLine(hTxtFileOut, "[Apollo Advanced Playlist]")
      TxtFileWriter_WriteLine(hTxtFileOut, "Version=1.00")
      TxtFileWriter_WriteLine(hTxtFileOut, "[Entries]")
      Else
      TxtFileWriter_WriteLine(hTxtFileOut, "[playlist]")
      EndIf
    For xLong1 = 0 To PLCount - 1
      If (PLI(xLong1)\DirDepthFlags & #PLI_IsAuto) = 0
        If Not (PLI(xLong1)\DirDepthFlags & #PLI_IsDir) = #PLI_IsDir
          xLong2 = xLong2 + 1
          TxtFileWriter_WriteLine(hTxtFileOut, EntryString + Str(xLong2) + "=" + PLI(xLong1)\Filename)
          EndIf
        EndIf
      Next
    For xLong1 = 0 To xRadioCount - 1
      xLong2 = xLong2 + 1
      TxtFileWriter_WriteLine(hTxtFileOut, EntryString + Str(xLong2) + "=" + xRadioURL(xLong1))
      Next
    TxtFileWriter_WriteLine(hTxtFileOut, "NumberOfEntries=" + Str(xLong2 + xRadioCount))
    If Not ApolloAap
      TxtFileWriter_WriteLine(hTxtFileOut, "Version=2")
      EndIf
    TxtFileWriter_Close(hTxtFileOut)
    xResult = #True
CompilerIf #UseFileLogging
    Else
    MainForm_ctConsoleA_AddLog("  failed")
CompilerEndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i PLWriter_Save_Wpl(Filename.s) ;, UseUTF8 As Boolean) as boolean
  Define.i xResult
  Define.i hTxtFileOut
  Define.i xLong1
  Define.i xLong2

  CompilerIf #UseFileLogging
    MainForm_ctConsoleA_AddLog("Saving playlist (wpl utf8): " + Filename)
    CompilerEndIf
    
  hTxtFileOut = TxtFileWriter_CreateFileEx(Filename, #CP_UTF8, #False)
  
  If Not hTxtFileOut = 0
    For xLong1 = 0 To PLCount - 1
      If (PLI(xLong1)\DirDepthFlags & #PLI_IsAuto) = 0
        If Not (PLI(xLong1)\DirDepthFlags & #PLI_IsDir) = #PLI_IsDir
          xLong2 = xLong2 + 1
          EndIf
        EndIf
      Next
    
    TxtFileWriter_WriteLine(hTxtFileOut, "<?wpl version=" + Chr(34) + "1.0" + Chr(34) + "?>")
    TxtFileWriter_WriteLine(hTxtFileOut, "<smil>")
    TxtFileWriter_WriteLine(hTxtFileOut, "    <head>")
    TxtFileWriter_WriteLine(hTxtFileOut, "        <meta name=" + Chr(34) + "Generator" + Chr(34) + " content=" + Chr(34) + "Calaym" + Chr(34) + "/>")
    TxtFileWriter_WriteLine(hTxtFileOut, "        <meta name=" + Chr(34) + "ItemCount" + Chr(34) + " content=" + Chr(34) + Str(xLong2 + xRadioCount) + Chr(34) + "/>")
    ;TxtFileWriter_WriteLine(hTxtFileOut, "        <title>" + PLWriter_GetPlaylistTitle(Filename) + "</title>")
    TxtFileWriter_WriteLine(hTxtFileOut, "    </head>")
    TxtFileWriter_WriteLine(hTxtFileOut, "    <body>")
    TxtFileWriter_WriteLine(hTxtFileOut, "        <seq>")
    For xLong1 = 0 To PLCount - 1
      If (PLI(xLong1)\DirDepthFlags & #PLI_IsAuto) = 0
        If Not (PLI(xLong1)\DirDepthFlags & #PLI_IsDir) = #PLI_IsDir
          TxtFileWriter_WriteLine(hTxtFileOut, "            <media src=" + Chr(34) + PLI(xLong1)\Filename + Chr(34) + "/>")
          EndIf
        EndIf
      Next
    For xLong1 = 0 To xRadioCount - 1
      TxtFileWriter_WriteLine(hTxtFileOut, "            <media src=" + Chr(34) + xRadioURL(xLong1) + Chr(34) + "/>")
      Next
    TxtFileWriter_WriteLine(hTxtFileOut, "        </seq>")
    TxtFileWriter_WriteLine(hTxtFileOut, "    </body>")
    TxtFileWriter_WriteLine(hTxtFileOut, "</smil>")
    TxtFileWriter_Close(hTxtFileOut)
    xResult = #True
CompilerIf #UseFileLogging
    Else
    MainForm_ctConsoleA_AddLog("  failed")
CompilerEndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i PLWriter_Save_Xspf(Filename.s)
  Define.i xResult
  Define.i hTxtFileOut
  Define.i xLong1

  CompilerIf #UseFileLogging
    MainForm_ctConsoleA_AddLog("Saving playlist (xspf utf8): " + Filename)
    CompilerEndIf
    
  hTxtFileOut = TxtFileWriter_CreateFileEx(Filename, #CP_UTF8, #True)
  If hTxtFileOut
    TxtFileWriter_WriteLine(hTxtFileOut, "<?xml version=" + Chr(34) + "1.0" + Chr(34) + " encoding=" + Chr(34) + "UTF-8" + Chr(34) + "?>")
    TxtFileWriter_WriteLine(hTxtFileOut, "<playlist version=" + Chr(34) + "1" + Chr(34) + " xmlns=" + Chr(34) + "http://xspf.org/ns/0/" + Chr(34) + ">")
    TxtFileWriter_WriteLine(hTxtFileOut, "  <trackList>")
    For xLong1 = 0 To PLCount - 1
      If (PLI(xLong1)\DirDepthFlags & #PLI_IsAuto) = 0
        If Not (PLI(xLong1)\DirDepthFlags & #PLI_IsDir) = #PLI_IsDir
          TxtFileWriter_WriteLine(hTxtFileOut, "    <track>")
          If Left(PLI(xLong1)\Filename, 2) = "\\"
            TxtFileWriter_WriteLine(hTxtFileOut, "      <location>file:" + URLEncode(ReplaceString(PLI(xLong1)\Filename, "\", "/"), ":/") + "</location>")
            Else
            TxtFileWriter_WriteLine(hTxtFileOut, "      <location>file:///" + URLEncode(ReplaceString(PLI(xLong1)\Filename, "\", "/"), ":/") + "</location>")
            EndIf
          TxtFileWriter_WriteLine(hTxtFileOut, "    </track>")
          EndIf
        EndIf
      Next
    For xLong1 = 0 To xRadioCount - 1
      TxtFileWriter_WriteLine(hTxtFileOut, "    <track>")
      TxtFileWriter_WriteLine(hTxtFileOut, "      <location>" + xRadioURL(xLong1) + "</location>")
      TxtFileWriter_WriteLine(hTxtFileOut, "    </track>")
      Next
    TxtFileWriter_WriteLine(hTxtFileOut, "  </trackList>")
    TxtFileWriter_WriteLine(hTxtFileOut, "</playlist>")
    TxtFileWriter_Close(hTxtFileOut)
    xResult = #True
CompilerIf #UseFileLogging
    Else
    MainForm_ctConsoleA_AddLog("  failed")
CompilerEndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i PLWriter_Save_AIMP(Filename.s, Header.s, EntryString.s) ;, UseUTF8 As Boolean) as boolean
  Define.i xResult
  Define.i hTxtFileOut
  Define.i xLong1
  Define.i xLong2

  CompilerIf #UseFileLogging
    If EntryString = "1|"
      MainForm_ctConsoleA_AddLog("Saving playlist (AIMP2): " + Filename)
      Else
      MainForm_ctConsoleA_AddLog("Saving playlist (AIMP3): " + Filename)
      EndIf
    CompilerEndIf
    
  hTxtFileOut = TxtFileWriter_CreateFileEx(Filename, #CP_WINUNICODE, #True)
  If Not hTxtFileOut = 0
    TxtFileWriter_WriteLine(hTxtFileOut, Header)
    For xLong1 = 0 To PLCount - 1
      If (PLI(xLong1)\DirDepthFlags & #PLI_IsAuto) = 0
        If Not (PLI(xLong1)\DirDepthFlags & #PLI_IsDir) = #PLI_IsDir
          xLong2 = xLong2 + 1
          TxtFileWriter_WriteLine(hTxtFileOut, EntryString + PLI(xLong1)\Filename)
          EndIf
        EndIf
      Next
    For xLong1 = 0 To xRadioCount - 1
      xLong2 = xLong2 + 1
      TxtFileWriter_WriteLine(hTxtFileOut, EntryString + ReplaceString(xRadioURL(xLong1), "|", "_"))
      Next
    TxtFileWriter_Close(hTxtFileOut)
    xResult = #True
CompilerIf #UseFileLogging
    Else
    MainForm_ctConsoleA_AddLog("  failed")
CompilerEndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i PLWriter_Save_M3u(Filename.s, OverWriteDef.i)
  Define.i xResult
  Define.i hTxtFileOut

  CompilerIf #UseFileLogging
    CompilerIf #PB_Compiler_Unicode
      MainForm_ctConsoleA_AddLog("Saving playlist (m3u ansi generic): " + Filename)
      CompilerElse
      MainForm_ctConsoleA_AddLog("Saving playlist (m3u ansi calaym): " + Filename)
      CompilerEndIf
    CompilerEndIf
    
  hTxtFileOut = TxtFileWriter_CreateFileEx(Filename, #CP_ACP, #False)
  If hTxtFileOut
    CompilerIf #PB_Compiler_Unicode
      PLWriter_Save_M3uGeneric(hTxtFileOut)
      CompilerElse
      PLWriter_Save_M3uCalaym(hTxtFileOut)
      If OverWriteDef And hTxtFileOut
        xCurPlistFilename = Filename
        xCurPlistFilenameSuggestNew = #False
        EndIf
      CompilerEndIf
    TxtFileWriter_Close(hTxtFileOut)
    xResult = #True
    EndIf
  CompilerIf #UseFileLogging
    If Not xResult
      MainForm_ctConsoleA_AddLog("  failed")
      EndIf
    CompilerEndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i PLWriter_Save_M3u8(Filename.s, OverWriteDef.i)
  Define.i xResult
  Define.i hTxtFileOut

  CompilerIf #UseFileLogging
    CompilerIf #PB_Compiler_Unicode
      MainForm_ctConsoleA_AddLog("Saving playlist (m3u8 utf8 calaym): " + Filename)
      CompilerElse
      MainForm_ctConsoleA_AddLog("Saving playlist (m3u8 utf8 generic): " + Filename)
      CompilerEndIf
    CompilerEndIf
    
  hTxtFileOut = TxtFileWriter_CreateFileEx(Filename, #CP_UTF8, #True)
  If Not hTxtFileOut = 0
    CompilerIf #PB_Compiler_Unicode
      PLWriter_Save_M3uCalaym(hTxtFileOut)
      If OverWriteDef And hTxtFileOut
        xCurPlistFilename = Filename
        xCurPlistFilenameSuggestNew = #False
        EndIf
      CompilerElse
      PLWriter_Save_M3uGeneric(hTxtFileOut)
      CompilerEndIf
    TxtFileWriter_Close(hTxtFileOut)
    xResult = #True
    EndIf
  CompilerIf #UseFileLogging
    If Not xResult
      MainForm_ctConsoleA_AddLog("  failed")
      EndIf
    CompilerEndIf
  ProcedureReturn xResult
  EndProcedure

Macro PLWriter_Save_AIMP2(Filename)
  PLWriter_Save_AIMP(Filename, "<" + PLWriter_GetPlaylistTitle(Filename) + ":0>", "1|")
  EndMacro

Macro PLWriter_Save_AIMP3(Filename)
  PLWriter_Save_AIMP(Filename, "#Name: " + PLWriter_GetPlaylistTitle(Filename), "#Track:1|")
  EndMacro

Macro PLWriter_Save_PLS(Filename)
  PLWriter_Save_PlsAap(Filename, "File", #False)
  EndMacro

Macro PLWriter_Save_AAP(Filename)
  PLWriter_Save_PlsAap(Filename, "Entry", #True)
  EndMacro

Procedure.i PLWriter_Save(Filename.s, OverWriteDef.i)
  Define.i xResult

  Select GetExtensionPart(Filename)
    Case "m3u8":   xResult = PLWriter_Save_M3u8(Filename, OverWriteDef)
    Case "m3u":    xResult = PLWriter_Save_M3u(Filename, OverWriteDef)
    Case "pls":    xResult = PLWriter_Save_PLS(Filename)
    Case "xspf":   xResult = PLWriter_Save_Xspf(Filename)
    Case "aimppl": xResult = PLWriter_Save_AIMP3(Filename)
    Case "plc":    xResult = PLWriter_Save_AIMP2(Filename)
    Case "aap":    xResult = PLWriter_Save_AAP(Filename)
    Case "wpl":    xResult = PLWriter_Save_Wpl(Filename)
    EndSelect
  If xResult
    xResult = #True
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 479
; FirstLine = 474
; Folding = --------
; EnableUnicode
; EnableXP