EnableExplicit

CompilerIf Not Defined(IncludePath, #PB_Constant)
  #IncludePath = #PB_Compiler_Home + "\ctcommons\"
  CompilerEndIf

  Macro MacroDoubleQuote
      "
    EndMacro

;Commons_Add    Global   loads/adds modules, procedures, macros etc
;Commons_Init   InProc   initializes / run procedures
;Commons_Close  InProc   Cleanup / run cleanup procedures
;Commons_Done   LastLn   Adds Cleanup procedure(s)

; Global = no in procedure!
; InProc = Anywhere, but in procedure if DLL
; LastLN = Your last line of code

Declare Commons_InitRealPost(AppName.s)
Declare Commons_Close()

Procedure Commons_InitRealPre()
  Global hInstance.i
  CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
    Global IsHighColor.i
    CompilerIf #PB_Compiler_Unicode
      Global IsMinWindows2000.i
      Global IsMinWindowsXP.i
      CompilerElse
      Global IsMinWindows98.i
      Global IsMinWindowsME.i
      CompilerEndIf
    CompilerEndIf
  Global IsMinWindowsVista.i
  Global IsMinWindows7.i
  Global *ptrTemp
  ;Global HtmlHelp_LastCall.i
  ;Global HtmlHelp_Active.i
  #DoeventsEx_SleepValueLow = 25
  #DoeventsEx_SleepValueHigh = 100
  #AsyncKeyPressedMask = $8000

  #ptrTempSize = 32000
  CompilerIf #PB_Compiler_Unicode
    #ptrTempSizeXAW = (#ptrTempSize >> 1) - 1
    CompilerElse
    #ptrTempSizeXAW = #ptrTempSize - 1
    CompilerEndIf
  EndProcedure

CompilerIf #PB_Compiler_Unicode
  Procedure.i GetProcAddress(*xModule, xName.s)
    PokeS(*ptrTemp, xName, -1, #PB_Ascii)
    ProcedureReturn GetProcAddress_(*xModule, *ptrTemp)
    EndProcedure
  Macro GetProcAddressAW(xModule, FncNoAW)
    GetProcAddress(xModule, FncNoAW + "W")
    EndMacro
  CompilerElse
  Macro GetProcAddress(xModule, xName)
    GetProcAddress_(xModule, xName)
    EndMacro
  Macro GetProcAddressAW(xModule, FncNoAW)
    GetProcAddress_(xModule, FncNoAW + "A")
    EndMacro
  CompilerEndIf

Macro StrS(xVal)
  Str(xVal)
  EndMacro

XIncludeFile #IncludePath + "OSMacros.pb"
XIncludeFile #IncludePath + "OtherMacros.pb"

Macro Commons_Add(ModuleName)
  CompilerIf Defined(Commons_Inited, #PB_Constant)
    CompilerElse
    
    #Commons_Inited = #True
    CompilerEndIf
  XIncludeFile #IncludePath + ModuleName + ".pb"
  EndMacro

Macro Commons_CondInit(CoreName)
  CompilerIf Defined(CoreName#_Init, #PB_Constant)
    CoreName#_Init()
    CompilerEndIf
  EndMacro



;XIncludeFile #IncludePath + "Application.pb"

Procedure Commons_Init(AppName.s)
  Commons_InitRealPre()
  ProcedureReturn Commons_InitRealPost(AppName)
  EndProcedure

CompilerIf #PB_Compiler_Debugger
  Macro Commons_PriorityWarning(ModuleHiChk, ModuleLowTrg)
    CompilerIf Defined(ModuleHiChk, #PB_Constant)
      CompilerIf Defined(ModuleHiChk#_Warn, #PB_Constant)
        xChar1 = MacroDoubleQuote#ModuleHiChk" + " must be included before " + MacroDoubleQuote#ModuleLowTrg"
        MessageBox_(0, @xChar1, @"ctCommons", #MB_ICONEXCLAMATION | #MB_OK)
        CompilerEndIf
      CompilerEndIf
    EndMacro
  CompilerEndIf


Macro Commons_Done()
  Procedure.i Commons_InitRealPost(AppName.s)
    Define.i xResult
    Define.i Major
    Define.i Minor
    Define.i xLong1
    Define.s xChar1

    CompilerIf #PB_Compiler_Debugger
      ;Define.s xChar1 ; priority warnings!
      CompilerEndIf
;Debug "Commons_InitRealPost()"

    If Not *ptrTemp
      *ptrTemp = LocalAlloc_(0, #ptrTempSize)
      EndIf
    CompilerIf #PB_Compiler_Debugger
      Commons_PriorityWarning(ToolTip, GetAPIPopupMenu)
      Commons_PriorityWarning(Shell_NotifyIcon, LoadResEx_WindowIcon_MultiOS)
      CompilerEndIf

    If *ptrTemp
      hInstance = GetModuleHandle_(0)
      Minor = GetVersion_()
      Major = (Minor & $FF)
      Minor = (Minor & $FF00) >> 8
  
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        If (Major >= 6)
          IsMinWindowsVista = #True
          If (Major = 6 And Minor >= 1) Or (Major > 6)
            IsMinWindows7 = #True
            EndIf
          EndIf
        CompilerElse
        CompilerIf #PB_Compiler_Unicode
          If (Major >= 5)
            IsMinWindows2000 = #True
            If (Major > 5) Or (Minor >= 1)
              IsMinWindowsXP = #True
              If (Major >= 6)
                IsMinWindowsVista = #True
                If (Major = 6 And Minor >= 1) Or (Major > 6)
                  IsMinWindows7 = #True
                  EndIf
                EndIf
              EndIf
            EndIf
          CompilerElse
          If (Major > 4 Or (Major = 4 And Minor >= 10))
            IsMinWindows98 = #True
            If Minor >= 90
              IsMinWindowsME = #True
              EndIf
            EndIf
          CompilerEndIf
        xLong1 = GetDC_(0)
        If xLong1
          If GetDeviceCaps_(xLong1, 12) > 15
            IsHighColor = #True
            EndIf
          ReleaseDC_(0, xLong1)
          EndIf
        CompilerEndIf


CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_Executable And #PB_Compiler_Unicode
  CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
        If IsMinWindowsXP
  CompilerEndIf
          xLong1 = LoadLibrary_(@"shell32.dll")
          InitCommonControls_()
          FreeLibrary_(xLong1)
  CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
          EndIf
  CompilerEndIf
CompilerEndIf


      Commons_CondInit(AppBase)


      CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
CompilerIf #PB_Compiler_Unicode
        If GetVersion_() & $80000000
CompilerElse
        If Not GetVersion_() & $80000000
CompilerEndIf
;216 The image file %1 is valid, but is For a machine type other than the current machine.  ERROR_EXE_MACHINE_TYPE_MISMATCH 
          Minor = FormatMessage_(#FORMAT_MESSAGE_FROM_SYSTEM | #FORMAT_MESSAGE_IGNORE_INSERTS, 0, #ERROR_EXE_MACHINE_TYPE_MISMATCH, 0, *ptrTemp, #ptrTempSizeXAW, 0)
          If Minor
            xChar1 = PeekS(*ptrTemp, Minor)
            If Not Len(AppName)
              CompilerIf Defined(GetFileVersionField, #PB_Constant)
                AppName = GetFileVersionField(#GetFileVersionField_ProductName)
                If Not Len(AppName)
                  AppName = "???"
                  EndIf
                CompilerElse
                AppName = "???"
                CompilerEndIf
              EndIf
            Else
            CompilerIf #PB_Compiler_Unicode
              xChar1 = "This is a unicode executable, which will not run this version of Windows."
              CompilerElse
              xChar1 = "This is a unicode executable, which will not run on Windows 95/98/ME. Contact the vendor of %1 "
              CompilerEndIf
            If Not Len(AppName)
              CompilerIf Defined(GetFileVersionField, #PB_Constant)
                AppName = GetFileVersionField(#GetFileVersionField_ProductName)
                If Not Len(AppName)
                  AppName = "this product"
                  EndIf
                CompilerElse
                AppName = "this product"
                CompilerEndIf
              EndIf
            EndIf
          xChar1 = ReplaceString(xChar1, "%1", AppName)
          MessageBox_(0, @xChar1, 0, #MB_ICONEXCLAMATION)
          LocalFree_(*ptrTemp)
          *ptrTemp = 0
          ProcedureReturn 0
          EndIf
        CompilerEndIf

      CompilerIf Defined(InitCommonControls_ProgressBar, #PB_Constant)
        #InitCommonControls_Do = #True
        CompilerElseIf Defined(InitCommonControls_TreeView, #PB_Constant)
        #InitCommonControls_Do = #True
        CompilerElseIf Defined(InitCommonControls_ListView, #PB_Constant)
        #InitCommonControls_Do = #True
        CompilerEndIf
      CompilerIf Defined(InitCommonControls_Do, #PB_Constant)
        Define.initcommoncontrolsex xType1
        CompilerIf Defined(InitCommonControls_ProgressBar, #PB_Constant)
          xLong1 | #InitCommonControls_ProgressBar
          CompilerEndIf
        CompilerIf Defined(InitCommonControls_TreeView, #PB_Constant)
          xLong1 | #InitCommonControls_TreeView
          CompilerEndIf
        CompilerIf Defined(InitCommonControls_ListView, #PB_Constant)
          xLong1 | #InitCommonControls_ListView
          CompilerEndIf
        xType1\dwSize = SizeOf(initcommoncontrolsex)
        xType1\dwICC = xLong1
        InitCommonControlsEx_(xType1)
        InitCommonControls_()
        CompilerEndIf
  
      CompilerIf Defined(CoInitialize, #PB_Constant)
        CoInitialize_(0)
        CompilerEndIf

      ;;; done already !!! Commons_CondInit(AppBase)
      Commons_CondInit(WaitableTimer)
      Commons_CondInit(RegisterDeviceNotification)
      Commons_CondInit(DPIScaling)
      Commons_CondInit(ThemingAPI)
      ProcedureReturn #True
      EndIf
    EndProcedure

  Procedure Commons_Close()
;Debug "Commons_Close()"
    CompilerIf Defined(HtmlHelp, #PB_Constant)
      If HtmlHelp_LastCall
        HtmlHelpClose()
        EndIf
      CompilerEndIf
    If *ptrTemp
      LocalFree_(*ptrTemp)
      EndIf
    EndProcedure
  EndMacro

Procedure DoEvents()
  Define.MSG xMsg
  While PeekMessage_(@xMsg, 0, 0, $3ff, #PM_REMOVE)
    TranslateMessage_(@xMsg)
    DispatchMessage_(@xMsg)
    Wend
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 105
; FirstLine = 90
; Folding = ----
; Executable = CleanupEmptyDirs.exe
; CommandLine = "T:\GameMusicRipp\2011\Alien Breed 2 - Assault"
; CompileSourceDirectory