EnableExplicit

XIncludeFile #IncludePath + "BitmapStretchCopyEx.pb"

Procedure IconFromEMF_ColorFix(hDC.i, *lpHTable, *lpEMFR.ENHMETARECORD, nObj.i, lpData.i)
  Define.i xEMRL_CBI.EMRCREATEBRUSHINDIRECT
  Define.i xEMRL_ECP.EMREXTCREATEPEN

  If *lpEMFR
    Select *lpEMFR\iType
      Case #EMR_CREATEBRUSHINDIRECT
        RtlMoveMemory_(@xEMRL_CBI, *lpEMFR, SizeOf(EMRCREATEBRUSHINDIRECT))
        xEMRL_CBI\lb\lbColor = $000000
        PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_CBI, nObj)
      Case #EMR_EXTCREATEPEN
        RtlMoveMemory_(@xEMRL_ECP, *lpEMFR, SizeOf(EMREXTCREATEPEN))
        xEMRL_ECP\elp\elpColor = $000000
        PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_ECP, nObj)
      Default
        PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
      EndSelect
    EndIf

  ProcedureReturn #True
  EndProcedure

Macro IconFromEMF_QualityShift(Value)
  (Value << 2)
  EndMacro

Procedure.i IconFromEMF(hMeta, SizeX, SizeY)
  Define.i xResult
  Define.i hDC
  Define.i hBmpOld
  Define.i hEmf
  Define.i hBrush
  Define.RECT xType1
  Define.ICONINFO xType2
  Define.i hBmpCol
  Define.i hBmpMsk

  If hMeta
    hDC = GetDC_(0)
    If hDC
      hBmpCol = CreateCompatibleBitmap_(hDC, IconFromEMF_QualityShift(SizeX), IconFromEMF_QualityShift(SizeY))
      hBmpMsk = CreateCompatibleBitmap_(hDC, IconFromEMF_QualityShift(SizeX), IconFromEMF_QualityShift(SizeY))
      ReleaseDC_(0, hDC)
      If hBmpCol
        If hBmpMsk
          hDC = CreateCompatibleDC_(0)
          If hDC
            hBmpOld = SelectObject_(hDC, hBmpCol)
            If hBmpOld
              xType1\right = IconFromEMF_QualityShift(SizeX)
              xType1\bottom = IconFromEMF_QualityShift(SizeY)
              hBrush = CreateSolidBrush_($808080)
              If hBrush
                FillRect_(hDC, xType1, hBrush)
                DeleteObject_(hBrush)
                EndIf
              If PlayEnhMetaFile_(hDC, hMeta, @xType1)
                If SelectObject_(hDC, hBmpMsk)
                  hBrush = CreateSolidBrush_($ffffff)
                  If hBrush
                    FillRect_(hDC, xType1, hBrush)
                    DeleteObject_(hBrush)
                    If EnumEnhMetaFile_(hDC, hMeta, @IconFromEMF_ColorFix(), 0, @xType1)
                      xResult = #True
                      EndIf
                    EndIf
                  EndIf
                EndIf
              SelectObject_(hDC, hBmpOld)
              If xResult
                xType2\fIcon = #True
                xType2\hbmColor = BitmapStretchCopyEx(hBmpCol, SizeX, SizeY)
                xResult = #False
                If xType2\hbmColor
                  xType2\hbmMask = BitmapStretchCopyEx(hBmpMsk, SizeX, SizeY)
                  If xType2\hbmMask
                    xResult = CreateIconIndirect_(@xType2)
                    DeleteObject_(xType2\hbmMask)
                    EndIf
                  DeleteObject_(xType2\hbmColor)
                  EndIf
                EndIf
              EndIf
            EndIf
          DeleteObject_(hBmpMsk)
          EndIf
        DeleteObject_(hBmpCol)
        ElseIf hBmpMsk
        DeleteObject_(hBmpMsk)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 27
; FirstLine = 15
; Folding = -
; EnableUnicode
; EnableXP