﻿EnableExplicit

XIncludeFile #IncludePath + "AppBase.pb"
XIncludeFile #IncludePath + "RegQueryValueEx_String.pb"
XIncludeFile #IncludePath + "RegEnumKey.pb"

Procedure.i RegisterFileTypes_GetRegistered(FileType.s, ProgramCaption.s, *IsDefaultRegistered)
  Define.i xResult
  Define.i xLong1
  Define.s xChar1
  Define.s xChar3

  If *IsDefaultRegistered
    PokeI(*IsDefaultRegistered, 0)
    EndIf
  
  FileType = LCase(FileType)
  xChar1 = "." + FileType
  If RegOpenKeyEx_($80000000, @xChar1, 0, 1, @xLong1)
    xChar1 = RegQueryValueEx_String(xLong1, 0)
    RegCloseKey_(xLong1)
    EndIf
  
  If Len(xChar1)
    xChar3 = xChar1
    xChar1 = xChar1 + "\Shell\" + ProgramCaption + "\Command"
    If RegOpenKeyEx_($80000000, @xChar1, 0, 1, @xLong1)
      xChar1 = RegQueryValueEx_String(xLong1, 0)
      If Len(xChar1)
        If LCase(xChar1) = Chr(34) + LCase(Commons_BasePathRealExe) + Chr(34) + " " + Chr(34) + "%1" + Chr(34)
          xResult = #True
          EndIf
        EndIf
      RegCloseKey_(xLong1)
      If *IsDefaultRegistered
        xChar1 = xChar3 + "\Shell"
        If RegOpenKeyEx_($80000000, @xChar1, 0, 1, @xLong1)
          xChar1 = RegQueryValueEx_String(xLong1, 0)
          If Len(xChar1)
            If (LCase(xChar1) = LCase(ProgramCaption))
              PokeI(*IsDefaultRegistered, #True)
              EndIf
            EndIf
          RegCloseKey_(xLong1)
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

;boolean
Procedure.i RegisterFileTypes_RemoveRegistered(FileType.s, ProgramCaption.s, DefaultActionBackupCaption.s = "")
  ;returns 0 if found itself;s deficon
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xBool1
  Define.s xChar1
  Define.s xChar3
  
  
  FileType = LCase(FileType)
  xChar1 = "." + FileType
  If RegOpenKeyEx_($80000000, @xChar1, 0, 1, @xLong1)
    xChar1 = RegQueryValueEx_String(xLong1, 0)
    RegCloseKey_(xLong1)
    EndIf
  
  If Len(xChar1)
    If Asc(xChar1) > 34 Or Asc(xChar1) = 33
    ;1/2?
      If RegOpenKeyEx_($80000000, 0, 0, 0, @xLong1)
        xChar3 = xChar1 + "\Shell\" + ProgramCaption
        RegDeleteKey_(xLong1, @xChar3)
        xChar3 = xChar1 + "\Shell"
        If RegOpenKeyEx_($80000000, @xChar3, 0, 8, @xLong2)
          xChar3 = RegEnumKey(xLong2, 0)
          If Len(xChar3)
            xChar3 = xChar1 + "\Shell"
            RegDeleteKey_(xLong1, @xChar3)
            EndIf
          RegCloseKey_(xLong2)
          EndIf
        RegCloseKey_(xLong1)
        EndIf
      EndIf
    
    If Not Len(DefaultActionBackupCaption) = 0
      xChar3 = xChar1 + "\Shell"
      If RegOpenKeyEx_($80000000, @xChar3, 0, 3, @xLong1)
        xChar3 = RegQueryValueEx_String(xLong1, @DefaultActionBackupCaption)
        If Len(xChar3)
          RegSetValueEx_String(xLong1, 0, xChar3)
          RegDeleteValue_(xLong1, @DefaultActionBackupCaption)
          EndIf
        EndIf
      EndIf
    
    xChar3 = xChar1 + "\DefaultIcon"
    If RegOpenKeyEx_($80000000, @xChar3, 0, 1, @xLong1)
      xChar3 = RegQueryValueEx_String(xLong1, 0)
      If Len(xChar3)
        xLong3 = 0
        Repeat
          xLong2 = FindString(xChar3, ",", xLong3 + 1)
          If xLong2 = 0
            Break
            EndIf
          xLong3 = xLong2
          ForEver
        If Not xLong3 = 0
          xChar3 = Left(xChar3, xLong3 - 1)
          EndIf
        If LCase(xChar3) = LCase(Commons_BasePathRealExe)
          xBool1 = #False
          EndIf
        EndIf
      RegCloseKey_(xLong1)
      EndIf
    If Not xBool1
      If RegOpenKeyEx_($80000000, 0, 0, 2, @xLong1)
        xChar3 = xChar1 + "\DefaultIcon"
        RegDeleteKey_(xLong1, @xChar3)
        xResult = #True
        RegCloseKey_(xLong1)
        EndIf
      EndIf
    xChar3 = xChar1 + "\Shell"
    If RegOpenKeyEx_($80000000, @xChar3, 0, 3, @xLong1)
      xChar3 = RegQueryValueEx_String(xLong1, 0)
      If Len(xChar3)
        If xChar3 = ProgramCaption
          RegDeleteValue_(xLong1, @"")
          EndIf
        EndIf
      RegCloseKey_(xLong1)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i RegisterFileTypes_SetRegistered(FileType.s, GlobalFileType.s, ProgramCaption.s, OpeningCaption.s, Description.s = "", Parameters.s = "", IconIndex.i = -1, AsDefaultRegistered.i = #False, PassiveRegistration.i = #True, DefaultActionBackupCaption.s = "")
  Define.i xResult
  Define.i xLong1
  Define.i xBool1
  Define.s xChar1
  Define.s xChar2
  
  FileType = LCase(FileType)
  If PassiveRegistration
    xChar1 = "." + FileType
    If RegOpenKeyEx_($80000000, @xChar1, 0, 1, @xLong1)
      xChar1 = RegQueryValueEx_String(xLong1, 0)
      If Len(xChar1)
        GlobalFileType = xChar1
        xBool1 = #True
        EndIf
      RegCloseKey_(xLong1)
      EndIf
    EndIf
  
  If Not xBool1
    xChar1 = "." + FileType
    If RegCreateKeyEx_($80000000, @xChar1, 0, 0, 0, 2, 0, @xLong1, *ptrTemp)
      RegSetValueEx_String(xLong1, 0, GlobalFileType)
      RegCloseKey_(xLong1)
      EndIf
    EndIf
  
  If (Not xBool1 Or AsDefaultRegistered)
    If RegCreateKeyEx_($80000000, @GlobalFileType, 0, 0, 0, 2, 0, @xLong1, *ptrTemp)
      RegSetValueEx_String(xLong1, 0, Description)
  ;    RegisterFileTypes_SetRegistered = #True
      RegCloseKey_(xLong1)
      EndIf
    EndIf
  
  xChar2 = LCase(Commons_BasePathRealExe)
  If Not AsDefaultRegistered
    ;1/2?
    xChar1 = GlobalFileType + "\DefaultIcon"
    If RegOpenKeyEx_($80000000, @xChar1, 0, 0, @xLong1)
      RegCloseKey_(xLong1)
      xBool1 = #False
      Else
      xBool1 = #True
      EndIf
    EndIf
  If (AsDefaultRegistered Or (xBool1 And Not IconIndex = -1))
    xChar1 = GlobalFileType + "\DefaultIcon"
    If RegCreateKeyEx_($80000000, @xChar1, 0, 0, 0, 2, 0, @xLong1, *ptrTemp)
      xChar1 = xChar2 + "," + StrU(IconIndex)
      RegSetValueEx_String(xLong1, 0, xChar1)
      xResult = #True
      RegCloseKey_(xLong1)
      EndIf
    EndIf
  
  If AsDefaultRegistered
    If Not Len(DefaultActionBackupCaption) = 0
      xChar1 = GlobalFileType + "\Shell"
      If RegOpenKeyEx_($80000000, @xChar1, 0, 3, @xLong1)
        xChar1 = RegQueryValueEx_String(xLong1, @DefaultActionBackupCaption)
        If Not Len(xChar1)
          xChar1 = RegQueryValueEx_String(xLong1, 0)
          If Len(xChar1)
            RegSetValueEx_String(xLong1, @DefaultActionBackupCaption, xChar1)
            EndIf
          EndIf
        EndIf
      EndIf
    xChar1 = GlobalFileType + "\Shell"
    If RegCreateKeyEx_($80000000, @xChar1, 0, 0, 0, 2, 0, @xLong1, *ptrTemp)
      RegSetValueEx_String(xLong1, 0, ProgramCaption)
      RegCloseKey_(xLong1)
      EndIf
    ElseIf Not Len(DefaultActionBackupCaption) = 0
    xChar1 = GlobalFileType + "\Shell"
    If RegOpenKeyEx_($80000000, @xChar1, 0, 3, @xLong1)
      xChar1 = RegQueryValueEx_String(xLong1, @DefaultActionBackupCaption)
      If Len(xChar1)
        RegSetValueEx_String(xLong1, 0, xChar1)
        RegDeleteValue_(xLong1, @DefaultActionBackupCaption)
        EndIf
      EndIf
    EndIf
  
  xChar1 = GlobalFileType + "\Shell\" + ProgramCaption
  If RegCreateKeyEx_($80000000, @xChar1, 0, 0, 0, 2, 0, @xLong1, *ptrTemp)
    RegSetValueEx_String(xLong1, 0, OpeningCaption)
    RegCloseKey_(xLong1)
    EndIf
  xChar1 = GlobalFileType + "\Shell\" + ProgramCaption + "\Command"
  If RegCreateKeyEx_($80000000, @xChar1, 0, 0, 0, 2, 0, @xLong1, *ptrTemp)
    xChar1 = Chr(34) + xChar2 + Chr(34) + " " + Chr(34) + "%1" + Chr(34)
    If Not Parameters = ""
      xChar1 = xChar1 + " " + Parameters
      EndIf
    RegSetValueEx_String(xLong1, 0, xChar1)
    RegCloseKey_(xLong1)
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 4
; Folding = -
; EnableUnicode
; EnableXP
; AddResource = ..\Calaym64\res\lng\en.rc