﻿EnableExplicit

XIncludeFile #IncludePath + "TxtFileReader_Core.pb"

Procedure.i TxtFileReader_OpenEx(Filename.s, *InOutEncoding, *PureTextSize, AppendAndSeekEnd.i)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  Define.i hFile
  Define.i InOutEncoding
  Define.i PureTextSize
  Define.i xBoolFail

  If AppendAndSeekEnd
    hFile = CreateFile_OpenRW(Filename)
    Else
    hFile = CreateFile_OpenRO(Filename)
    EndIf
  If Not hFile = -1
    PureTextSize = GetFileSize_(hFile, xLong1)
    If xLong1 = 0 And PureTextSize < $4000000
      InOutEncoding = PeekI(*InOutEncoding)
      If ReadFile_(hFile, @xLong1, 3, @xLong2, 0)
        If (xLong1 & $FFFF) = $FEFF
          If Not (PureTextSize & 1)
            PureTextSize - 2
            InOutEncoding = #CP_WINUNICODE
            If Not AppendAndSeekEnd
              If (SetFilePointer_(hFile, 2, 0, 0) & $ffffffff) = $ffffffff
                xBoolFail = #True
                Else
                xResult = hFile
                EndIf
              EndIf
            EndIf
          ElseIf (xLong1 & $FFFFFF) = $BFBBEF
          PureTextSize = PureTextSize - 3
          InOutEncoding = #CP_UTF8
          If Not AppendAndSeekEnd
            xResult = hFile
            EndIf
          EndIf
        EndIf
      If Not xResult
        If Not xBoolFail
          If (PureTextSize & 1) = 0 Or InOutEncoding <> #CP_WINUNICODE
            If AppendAndSeekEnd
              AppendAndSeekEnd = 2
              EndIf
            If Not ((SetFilePointer_(hFile, 0, 0, AppendAndSeekEnd) & $ffffffff) = $ffffffff)
              xResult = hFile
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    If xResult
      PokeI(*InOutEncoding, InOutEncoding)
      PokeI(*PureTextSize, PureTextSize)
      Else
      CloseHandle_(hFile)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i TxtFileReader_FromFile(Filename.s, DefaultEncoding = #CP_ACP)
  Define.i xResult
  Define.i hFile
  Define.i xSize
  Define.i xLong1
  Define.i xLong2
  Define *hMemTmp
  Define *xType1.TxtFileReadStruct

  hFile = TxtFileReader_OpenEx(Filename, @DefaultEncoding, @xSize, #False)
  If Not hFile = -1
    *xType1 = LocalAlloc_(#LMEM_ZEROINIT, SizeOf(TxtFileReadStruct))
    If *xType1
      If xSize = 0
        xResult = *xType1
        Else
        If DefaultEncoding = #CP_WINUNICODE
          *xType1\hMem = LocalAlloc_(0, xSize + 6)
          If *xType1\hMem
            If ReadFile_(hFile, *xType1\hMem, xSize, @xLong1, 0)
              If xSize = xLong1
                xResult = *xType1
                EndIf
              EndIf
            EndIf
          Else
          *hMemTmp = LocalAlloc_(0, xSize + 1)
          If *hMemTmp
            If ReadFile_(hFile, *hMemTmp, xSize, @xLong1, 0)
              If xSize = xLong1
                xLong1 = MultiByteToWideChar_(DefaultEncoding, 0, *hMemTmp, xSize, 0, 0)
                If xLong1
                  *xType1\hMem = LocalAlloc_(0, (xLong1 << 1) + 8)
                  If *xType1\hMem
                    xLong2 = MultiByteToWideChar_(DefaultEncoding, 0, *hMemTmp, xSize, *xType1\hMem, xLong1)
                    If xLong1 = xLong2
                      xSize = xLong1 << 1
                      xResult = *xType1
                      EndIf
                    EndIf
                  EndIf
                EndIf
              EndIf
            LocalFree_(*hMemTmp)
            EndIf
          EndIf
        If xResult
          *xType1\Encoding = DefaultEncoding
          *xType1\hMemPos = *xType1\hMem
          *xType1\hMemEnd = *xType1\hMem + xSize
          PokeW(*xType1\hMemEnd+0, 13)
          PokeW(*xType1\hMemEnd+2, 10)
          PokeW(*xType1\hMemEnd+4,  0)
          xResult = *xType1
          ElseIf *xType1\hMem
          LocalFree_(*xType1\hMem)
          EndIf
        EndIf
      If Not xResult
        LocalFree_(*xType1)
        EndIf
      EndIf
    CloseHandle_(hFile)
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 77
; FirstLine = 75
; Folding = -
; EnableUnicode
; EnableXP