﻿EnableExplicit

Structure TxtFileWriteStruct
  hFile.i
  ; same offset as in read counterpart!!!
  Encoding.i
  EndStructure

Procedure.i TxtFileWriter_CreateFileEx(Filename.s, Encoding.i, ByteOrderMark.i)
  Define.i xResult
  Define.i Success1
  Define.i xLong1
  Define.i xLong2
  Define.TxtFileWriteStruct xType1

  xType1\hFile = CreateFile_CreateWO(Filename)
  If Not xType1\hFile = -1
    If SetEndOfFile_(xType1\hFile)
      If ByteOrderMark
        If Encoding = #CP_WINUNICODE
          xLong1 = $FEFF
          If WriteFile_(xType1\hFile, @xLong1, 2, @xLong2, 0)
            If (xLong2 = 2)
              Success1 = #True
              EndIf
            EndIf
          ElseIf Encoding = #CP_UTF8
          xLong1 = $BFBBEF
          If WriteFile_(xType1\hFile, @xLong1, 3, @xLong2, 0)
            If (xLong2 = 3)
              Success1 = #True
              EndIf
            EndIf
          ElseIf Encoding = #CP_ACP
          Success1 = #True
          EndIf
        Else
        Success1 = #True
        EndIf
      If Success1
        xResult = LocalAlloc_(0, SizeOf(TxtFileWriteStruct))
        If xResult
          xType1\Encoding = Encoding
          RtlMoveMemory_(xResult, @xType1, SizeOf(TxtFileWriteStruct))
          EndIf
        EndIf
      EndIf
    If Not xResult
      CloseHandle_(xType1\hFile)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

CompilerIf #PB_Compiler_Unicode
  Macro TxtFileWriter_CreateFile(Filename)
    TxtFileWriter_CreateFileEx(Filename, #CP_WINUNICODE, #True)
    EndMacro
  CompilerElse  
  Macro TxtFileWriter_CreateFile(Filename)
    TxtFileWriter_CreateFileEx(Filename, #CP_ACP, #False)
    EndMacro
  CompilerEndIf

;boolean
Procedure.i TxtFileWriter_WriteString(*hTxtFileOut.TxtFileWriteStruct, xString.s)
  Define.i xResult
  Define.i xSize
  Define.i xLong1
  Define *MemA
  Define *MemC

  If *hTxtFileOut
    If Not *hTxtFileOut\hFile = -1
      xSize = Len(xString)
      If xSize
        Select *hTxtFileOut\Encoding
          Case #CP_WINUNICODE
            CompilerIf #PB_Compiler_Unicode
              *MemC = @xString
              xSize << 1
              CompilerElse
              xSize << 1
              *MemA = LocalAlloc_(0, xSize + 2)
              xLong1 = PokeS(*MemA, xString)
              If xLong1 = xSize
                *MemC = *MemA
                EndIf
              CompilerEndIf
          Case #CP_UTF8
            xSize = StringByteLength(xString, #PB_UTF8)
            If xSize
              *MemA = LocalAlloc_(0, xSize + 1)
              If *MemA
                xLong1 = PokeS(*MemA, xString, -1, #PB_UTF8)
                If xLong1 = xSize
                  *MemC = *MemA
                  EndIf
                EndIf
              EndIf
          Case #CP_ACP
            CompilerIf #PB_Compiler_Unicode
              *MemA = LocalAlloc_(0, xSize + 1)
              xLong1 = PokeS(*MemA, xString, -1, #PB_Ascii)
              If xLong1 = xSize
                *MemC = *MemA
                EndIf
              CompilerElse
              *MemC = @xString
              CompilerEndIf
          EndSelect
        If *MemC
          If WriteFile_(*hTxtFileOut\hFile, *MemC, xSize, @xLong1, 0)
            If xLong1 = xSize
              xResult = #True
              EndIf
            EndIf
          EndIf
        If *MemA
          LocalFree_(*MemA)
          EndIf
        If Not xResult
          SetEndOfFile_(*hTxtFileOut\hFile)
          CloseHandle_(*hTxtFileOut\hFile)
          *hTxtFileOut\hFile = -1
          EndIf
        Else
        xResult = #True
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Macro TxtFileWriter_WriteLine(hTxtFileOut, xLine)
  TxtFileWriter_WriteString(hTxtFileOut, xLine + Chr(13) + Chr(10))
  EndMacro

Procedure TxtFileWriter_Close(*hTxtFileOut.TxtFileWriteStruct)
  If *hTxtFileOut
    If Not *hTxtFileOut\hFile = -1
      SetEndOfFile_(*hTxtFileOut\hFile)
      CloseHandle_(*hTxtFileOut\hFile)
      EndIf
    LocalFree_(*hTxtFileOut)
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 59
; FirstLine = 53
; Folding = --
; EnableUnicode
; EnableXP